 ##############################################################################
#
# Wolframagaz (powered by WolframAlpha - Computational knowledge engine)
# v1.01 (29/04/2012)   2012 MenzAgitat
#
# IRC: irc.epiknet.org  #boulets / #eggdrop
#
# Mes scripts sont tlchargeables sur http://www.eggdrop.fr
#
 ##############################################################################

#
# Remerciements  ealexp pour la proc split_line et le beta testing.
#

#
# Description
#
# Wolframagaz est une interface permettant d'utiliser les services de
# WolframAlpha (www.wolframalpha.com) par son API.
# 
# Il s'agit d'un genre de super-cerveau capable de vous fournir des donnes
# sur  peu prs n'importe quoi, de faire des calculs complexes, des
# conversions, ...
# Vous pouvez voir une liste non-exhaustive des possibilits ici :
# http://www.wolframalpha.com/examples/
#
# Les rsultats subissent un traitement pour en dgager l'information
# exploitable, qui est ensuite organise et formate d'une faon propice 
# l'affichage sur un canal IRC.
#
# Les recherches doivent tre faites en anglais, et les requtes en langage
# naturel sont prises en compte dans une certaine mesure.
# Si la langue anglaise est une barrire pour vous, vous pouvez toujours
# utiliser Wolframagaz comme une calculatrice.
#
# Si l'option suggest_additional_categories_if_truncated est active et que
# l'affichage des rsultats a t tronqu en raison d'une longueur excessive,
# il devient possible pour l'utilisateur de demander l'affichage de catgories
# supplmentaires en les appelant simplement par leur numro.
# L'exemple suivant en dmontre le principe :
#		<MenzAgitat> !wolfram pi
#		<Boole> Decimal approximation (1): 3.1415926535897932384626433832795028841971693993751058209749... | Property (2): pi is a transcendental number | Continued fraction (3): [3; 7, 15, 1, 292, 1, 1, 1, 2, 1, 3, 1, 14, 2, 1, 1, 2, 2, 2, 2, 1, 84, 2, 1, 1, ...] | Alternative representations (4): pi = 180 ° | pi = -i log(-1) | pi = cos^(-1)(-1) | Series representations (5(...)
#		<Boole> Des rsultats additionnels sont disponibles dans les catgories suivantes : Series representations (5) | Integral representations (6)
#		<MenzAgitat> 5
#		<Boole> Series representations: pi = 4 sum_(k=0)^infinity(-1)^k/(2 k+1) | pi = -2+2 sum_(k=1)^infinity2^k/(2 k | k) | pi = sum_(k=0)^infinity(50 k-6)/(2^k (3 k | k))
#		<MenzAgitat> 6
#		<Boole> Integral representations: pi = 2 integral_0^infinity1/(t^2+1) dt | pi = 4 integral_0^1 sqrt(1-t^2) dt | pi = 2 integral_0^infinity(sin(t))/t dt
# L'interrogation des rsultats supplmentaires est possible pendant 30 secondes
# (paramtrable) aprs la requte principale et chaque nouvelle demande de
# catgorie redonne 30 secondes.
#
# Pour activer Wolframagaz sur un chan, vous devez taper ceci en partyline :
# .chanset #NomDuChan +wolfram
# et pour le dsactiver :
# .chanset #NomDuChan -wolfram
#


#
# Changelog
#
# 1.0
#		- 1re version
# 1.01
#		- Correction d'un bug pouvant provoquer une erreur lorsqu'un rsultat
#			pouvait tre interprt de plusieurs faons diffrentes.
#

#
# Licence
#
#		Cette cration est mise  disposition selon le Contrat
#		Attribution-NonCommercial-ShareAlike 3.0 Unported disponible en ligne
#		http://creativecommons.org/licenses/by-nc-sa/3.0/ ou par courrier postal 
#		Creative Commons, 171 Second Street, Suite 300, San Francisco, California
#		94105, USA.
#		Vous pouvez galement consulter la version franaise ici :
#		http://creativecommons.org/licenses/by-nc-sa/3.0/deed.fr
#

if {[info commands ::Wolframagaz::uninstall] eq "::Wolframagaz::uninstall"} { ::Wolframagaz::uninstall }
# Note pour les programmeurs :
# Dans la version 1.6.19 d'eggdrop, le numro de version affich par .vbottree
# et [numversion] est incorrect; il affiche 1061800 ou 1061801, ce qui
# correspond  la version 1.6.18. On utilise donc une autre technique pour
# vrifier le numro de version.
if { [join [split [::tcl::string::range [lindex $version 0] 0 5] "."] ""] < 1620 } { putloglev o * "\00304\002\[Wolframagaz - ERREUR\]\002\003 La version de votre eggdrop est \00304\002$version\002\003; \002Wolframagaz\002 ne fonctionnera correctement que sur les eggdrops version 1.6.20 ou suprieure." ; return }
if { [info tclversion] < 8.5 } { putloglev o * "\00304\002\[Wolframagaz - ERREUR\]\002\003 \002Wolframagaz\002 ncessite que Tcl 8.5 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.5
namespace eval Wolframagaz {


	 ############################################################################
	# CONFIGURATION
	 ############################################################################

	# Cl d'API
	# Pour obtenir gratuitement une cl d'API : http://products.wolframalpha.com/api/
	variable API_key "XXXXXX-XXXXXXXXXX"

	# Commande(s) publique(s), spares par un espace si vous en mettez plusieurs
	variable commands "!wolfram"

	# Autorisations requises pour utiliser la commande publique
	variable command_flags "-|-"

	# Temps maximum allou  WolframAlpha pour la rsolution de la requte (en secondes)
	variable timeout 10

	# URL (n'y touchez pas  moins d'avoir une bonne raison de le faire)
	variable base_URL "http://api.wolframalpha.com/v2/query?format=plaintext&appid=[set API_key]&scantimeout=[set timeout]"

	# User-Agent (n'y touchez pas  moins d'avoir une bonne raison de le faire)
	variable user_agent "Mozilla/5.0 (Windows; U; Windows NT 6.1; en-GB; rv:1.9.2.2) Gecko/20100316 Firefox/3.6.2"

	# Nombre maximum de caractres affichables par ligne. Si la fin de certaines
	# lignes est tronque, cela signifie que vous devez diminuer cette valeur.
	variable max_line_length 435

	# Nombre maximum de lignes de rsultats  afficher
	# (n'inclut pas l'numration des catgories possibles de rsultats et ne
	# concerne pas les demandes de rsultat complmentaire)
	variable max_lines_for_primary_results 1

	# Nombre maximum de lignes  afficher lors d'une demande de rsultat
	# complmentaire
	variable max_lines_per_additional_result 2

	# Afficher une liste des catgories possibles de rsultats si l'affichage des
	# rsultats a t tronqu en raison de sa longueur excessive ?
	# (0 = non ; 1 = oui)
	# Note : Activer cette option permet  l'utilisateur de demander l'affichage
	# de catgories de rsultats supplmentaires si toutes n'ont pu tre affiches.
	variable suggest_additional_categories_if_truncated 1

	# Autorise-t-on Wolframagaz  rpter plusieurs fois une mme catgorie de
	# rsultats si on le lui demande ? (0 = non ; 1 = oui)
	variable is_allowed_to_repeat 0

	# Afficher les avertissements s'il y en a ? (0 = non ; 1 = oui)
	# Note : un avertissement peut concerner un mot mal orthographi qui a t
	# corrig par WolframAlpha, une parenthse dsquilibre dans un calcul,
	# etc... Toute erreur n'empchant pas la rsolution de la requte gnre
	# un avertissement.
	variable show_warnings 1

	# Temps (en secondes) pendant lequel il est possible de demander l'affichage
	# de catgories de rsultats supplmentaires.
	# Notez que toute demande de prcisions relance une nouvelle session de ce
	# compteur.
	variable results_life_duration 30


	#### PARAMETRES DE L'ANTI-FLOOD
	#
	# Activer l'anti-flood ? (0 = non ; 1 = oui)
	variable antiflood_enabled 1

	# Combien de requtes (incluant les demandes d'affichage de catgories
	# supplmentaires) sont autorises pour un mme utilisateur sur un mme chan
	# en un temps donn ?
	# Exemple : "10:300" = 10 requtes maximum en 300 secondes
	variable antiflood_per_user "10:300"

	# Combien de requtes (incluant les demandes d'affichage de catgories
	# supplmentaires) sont autorises pour tous les utilisataurs d'un mme chan
	# en un temps donn ?
	# Exemple : "20:600" = 20 requtes maximum en 600 secondes
	variable antiflood_per_chan "20:600"

	# Intervalle de temps minimum entre l'affichage de 2 messages
	# avertissant que l'anti-flood a t dclench.
	# Le temps est exprim en secondes.
	# Ne rglez pas cette valeur trop bas afin de ne pas tre flood par les
	# messages d'avertissement de l'anti-flood.
	variable antiflood_msg_interval 30


	#### PARAMETRES VISUELS

	# Activer le mode monochrome ? (0 = non ; 1 = oui)
	# Ce mode supprime toutes les couleurs / gras / soulignements des affichages
	# du script, aussi bien en public que sur le chan et en partyline.
	variable monochrome 0

	# Symbole  superposer  la fin d'une rponse pour indiquer que la ligne a
	# t tronque.
	variable line_cut_pattern "\00304(...)\003"

	# Symbole  utiliser comme sparateur entre les catgories de rsultats
	variable categories_separator " \00307|\003 "

	# Symbole  utiliser comme sparateur entre diffrents rsultats d'une mme
	# catgorie
	variable results_separator " \00314|\003 "

	# Rgles syntaxiques concernant les couleurs :
	# 	- Pour les valeurs infrieures  10, vous devez lez faire prcder d'un 0.
	#			Exemples :
	#				pour la couleur 4 (rouge), vous devez mettre 04
	#				pour du rouge sur fond bleu, vous devez mettre 04,12
	# 	- Si vous ne voulez aucune couleur, mettez ""

	# Couleur du nom des catgories de rsultats
	variable category_title_color ""

	# Couleur des numros des catgories de rsultats
	variable category_number_color "10"
	
	# Couleur du nom des sous-catgories de rsultats 
	variable subcategory_title_color "14"





 ##############################################################################
#
# NE MODIFIEZ RIEN APRES CECI SI VOUS NE CONNAISSEZ PAS LE TCL
#
# DO NOT MODIFY ANYTHING BELOW IF YOU DON'T KNOW TCL
#
 ##############################################################################


	 ############################################################################
	### Initialisation
	 ############################################################################
  variable scriptname "Wolframagaz (powered by WolframAlpha - Computational knowledge engine)"
  variable version "1.01.20120429"
	variable DEBUGMODE 0
	setudef flag wolfram
	scan $antiflood_per_user "%d:%d" ::Wolframagaz::max_instances_per_user ::Wolframagaz::per_user_instance_length
	scan $antiflood_per_chan "%d:%d" ::Wolframagaz::max_instances_per_chan ::Wolframagaz::per_chan_instance_length
	array set ::Wolframagaz::antiflood_instances {}
	# Procdure de dsinstallation
	# (le script se dsinstalle totalement avant chaque rehash ou  chaque relecture au moyen de la commande "source" ou autre)
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$::Wolframagaz::scriptname\002..."
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [::tcl::string::range [namespace current] 2 end]]*] " \{?(::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		foreach running_timer [timers] {
			if { [::tcl::string::match "*[namespace current]::*" [lindex $running_timer 1]] } { killtimer [lindex $running_timer 2] }
		}
		foreach running_utimer [utimers] {
			if { [::tcl::string::match "*[namespace current]::*" [lindex $running_utimer 1]] } { killutimer [lindex $running_utimer 2] }
		}
		namespace delete ::Wolframagaz
	}
}


 ##############################################################################
### Procdure principale
 ##############################################################################
proc Wolframagaz::main {nick host hand chan text} {
	if {![channel get $chan wolfram]} { return }
	if { $Wolframagaz::API_key eq "XXXXXX-XXXXXXXXXX" } {
		puthelp "PRIVMSG $chan :[c 04 $chan]\[Wolframagaz - erreur\][c e $chan] Vous n'avez pas dfini votre cl d'API; veuillez vous rendre  l'adresse http://products.wolframalpha.com/api/ afin d'en crer une, puis reportez-vous  la configuration de ce script afin de rgler l'option API_key."
		return
	}
	set chan_hash [md5 $chan]
	# si une recherche prcdente est encore en cours
	if { [lsearch -regexp [binds] "pubm -\\|- \\{$chan \\*\\} \[0-9\]+ ::Wolframagaz::request_additional_results"] != -1 } {
		set utimers_snapshot [utimers]
		set utimer_content [lindex $utimers_snapshot [lsearch -index 1 $utimers_snapshot "::Wolframagaz::previous_results_just_expired $chan"]]
		set remaining_time [lindex $utimer_content 0]
		# si le demandeur est diffrent de celui qui a une recherche en cours,
		# on arrte
		if { $nick != [set ::Wolframagaz::reusable_results_[set chan_hash](nick)] } {
			puthelp "PRIVMSG $chan :[c 14 $chan]\[Wolframagaz\][c e $chan] Une autre recherche est actuellement en cours. Veuillez ressayer d'ici $remaining_time [::Wolframagaz::plural $remaining_time "seconde" "secondes"]."
			return
		# si le demandeur est identique  celui qui a une recherche en cours,
		# on nettoie tout avant de faire une nouvelle recherche
		} else {
			unbind pubm $::Wolframagaz::command_flags "$chan *" ::Wolframagaz::request_additional_results
			killutimer [lindex $utimer_content 2]
			array unset ::Wolframagaz::reusable_results_[set chan_hash]
		}
	}
	# Antiflood
	if { ($::Wolframagaz::antiflood_enabled)
		&& (([::Wolframagaz::antiflood user $nick $host $chan])
		|| ([::Wolframagaz::antiflood chan $nick $host $chan]))
	} then { return }
	# envoi de la requte et rception des donnes
	append URL $::Wolframagaz::base_URL & [::http::formatQuery input $text]
	::http::config -useragent $::Wolframagaz::user_agent
	set token [::http::geturl $URL -timeout [expr ($::Wolframagaz::timeout + 1) * 1000]]
	if {[::http::status $token] eq "ok"} {
		set received_data [::Wolframagaz::html_filter [::http::data $token]]
		if { $::Wolframagaz::DEBUGMODE } {
			set fileID [open "scripts/wolframagaz_output.txt" w]
			puts $fileID "---------------------------- $URL"
			puts $fileID $received_data
			close $fileID
		}
		# on prpare la mise en forme des rsultats
		set index2 0
		while { [regexp -indices -start $index2 {<plaintext>.*?</plaintext>} $received_data plaintext_section_coordinates] } {
			set plaintext_section [::tcl::string::range $received_data [set index1 [lindex $plaintext_section_coordinates 0]] [set index2 [lindex $plaintext_section_coordinates 1]]]
			regsub -all {\n+} $plaintext_section "!!_:_!!" plaintext_section
			regsub -all {((\s+)?(\||!!_:_!!)(\s+)?){1,}} $plaintext_section "!!_:_!!" plaintext_section
			regsub -all {((\s+)?\|(\s+)?){1,}} $plaintext_section [::Wolframagaz::filter_codes $::Wolframagaz::results_separator $chan] plaintext_section
			regsub {<plaintext>!!_:_!!} $plaintext_section "<plaintext>" plaintext_section
			regsub {!!_:_!!</plaintext>} $plaintext_section "</plaintext>" plaintext_section
			regsub -all {:!!_:_!!} $plaintext_section ": " plaintext_section
			set received_data [::tcl::string::replace $received_data $index1 $index2 $plaintext_section] 
		}
		set index2 0
		while { [regexp -indices -start $index2 {(?:<pod title='(.*?)')} $received_data {} pod_title_section_coordinates] } {
			set pod_title_section [::tcl::string::range $received_data [set index1 [lindex $pod_title_section_coordinates 0]] [set index2 [lindex $pod_title_section_coordinates 1]]]
			regsub -all {=} $pod_title_section "!!_::_!!" pod_title_section
			set received_data [::tcl::string::replace $received_data $index1 $index2 $pod_title_section] 
		}
		# suppression des espaces/sauts de lignes superflus
		regsub -all {\s+} $received_data " " received_data
		if { $::Wolframagaz::DEBUGMODE } { set ::Wolframagaz::_received_data $received_data }
		#################################################### Parsing de queryresult
		# cration de l'array queryresult
		regexp {<queryresult\s(.+?)/?>} $received_data {} raw_queryresult
		if { $raw_queryresult eq "" } {
			::Wolframagaz::error missing_queryresult $chan
			::http::cleanup $token
			return
		}
		array set queryresult [::tcl::string::map {"=" " " "'" "\""} $raw_queryresult] 	 ;#"
		####################################################### Parsing des erreurs
		# cration de l'array error
		regexp {<queryresult\s(?:.+?)/?>\s+?<error>\s+?(.+?)\s+?</error>} $received_data {} raw_errors
		if { [info exists raw_errors] } {
			lappend errors [regsub -all {<.+?>} $raw_errors {"}] 	 ;#"
		} else {
			set errors "none"
		}
		########################################################## Parsing des tips
		# cration de l'array tips
		regexp {<tips\s(.+?)>} $received_data {} raw_tips
		if { [info exists raw_tips] } {
			array set tips [::tcl::string::map {"=" " " "'" "\""} $raw_tips] 	 ;#"
			# rcupration des tips dans $tips(results)
			foreach {{} tip} [regexp -all -inline {<tip text='(.+?)'\s+/>} $received_data] {
				lappend tips(results) [::Wolframagaz::translate $tip]
			}
		} else {
			set raw_tips "none"
		}
		# si WolframAlpha n'a pas pu traiter la requte, on affiche l'erreur et on arrte
		if { $queryresult(success) eq "false" } {
			if { $queryresult(parsetimedout) eq "true" } {
				::Wolframagaz::error parsetimedout $chan
			} elseif { $queryresult(error) eq "true" } {
				foreach error $errors {
					foreach {error_code error_msg} $error {
						if { [info exists errors_output] } { append errors_output [::Wolframagaz::filter_codes $::Wolframagaz::results_separator $chan] }
						append errors_output "[::Wolframagaz::translate $error_msg] [c 14 $chan](code: $error_code)[c e $chan]"
					}
				}
				::Wolframagaz::error $errors_output $chan
			} else {
				::Wolframagaz::error request_failed $chan
			}
			if { $raw_tips ne "none" } { puthelp "PRIVMSG $chan :[c u $chan]Suggestions[c u $chan] : [join $tips(results) [::Wolframagaz::filter_codes $::Wolframagaz::categories_separator $chan]]" }
			::http::cleanup $token
			return
		}
		########################################################## Parsing des warnings
		regexp -all {<warnings\s(?:.+?)</warnings>} $received_data raw_warnings
		if { [info exists raw_warnings] } {
			# rcupration des warnings dans $warnings(results)
			foreach {{} warning} [regexp -all -inline {\stext='(.+?)'\s} $raw_warnings] {
				lappend warnings [::Wolframagaz::translate $warning]
			}
		} else {
			set warnings "none"
		}
		########################################################## Parsing des pods
		# cration des arrays contenant les proprits des pods sous la forme : pod_<id du pod>
		set raw_pods [regexp -all -inline {<pod\s(?:.+?)</pod>} $received_data]
		if { $raw_pods eq "" } {
			::Wolframagaz::error missing_pod $chan
			::http::cleanup $token
			return
		}
		foreach raw_pod $raw_pods {
			regexp {<pod\s(.+?)>} $raw_pod {} pod_properties
			regexp {id='(.+?)'} $pod_properties {} pod_id
			regsub -all {[^[:alnum:]]} $pod_id "" pod_id
			array set pod_[set pod_id] [::tcl::string::map {"=" " " "!!_::_!!" "=" "\"" "'" "'" "\""} $pod_properties]  ;#"
			# ajout du pod_id  la liste des pod_id
			lappend pod_id_list $pod_id 
			# rcupration des rsultats du pod en cours dans $pod_$pod_id(results)
			foreach {{} subpod_title subpod_plaintext} [regexp -all -inline {<subpod title='(.*?)'.*?>\s+<plaintext>(?:\s+)?(.*?)(?:\s+)?</plaintext>} $raw_pod] {
				lappend pod_[set pod_id](results) $subpod_title $subpod_plaintext
			}
		}
		################################################### Parsing des assumptions
		# cration de l'array contenant les proprits globales des assumptions
		regexp {<assumptions\s(.+?)>} $received_data {} raw_assumptions
		if { [info exists raw_assumptions] } {
			array set assumptions [::tcl::string::map {"=" " " "'" "\""} $raw_assumptions] 	 ;#"
			# cration des arrays contenant les assumptions sous la forme assumption_<type>
			set raw_assumptions [regexp -all -inline {<assumption\s(?:.+?)</assumption>} $received_data]
			foreach raw_assumption $raw_assumptions {
				regexp {<assumption\s(.+?)>} $raw_assumption {} assumption_properties
				regexp {type='(.+?)'} $assumption_properties {} assumption_id
				array set assumption_[set assumption_id] [::tcl::string::map {"=" " " "\"" "\\\"" "'" "\""} $assumption_properties]  ;#"
				# ajout du assumption_id  la liste des assumption_id
				lappend assumption_id_list $assumption_id 
				# rcupration des rsultats de l'assumption en cours dans $assumption_$assumption_id(results)
				foreach {{} value_name value_data} [regexp -all -inline {<value name='(.+?)'\s+(.+?)/>} $raw_assumption] {
					lappend assumption_[set assumption_id](results) $value_name [::tcl::string::map {"=" " " "'" "\""} $value_data]  ;#"
				}
			}
		} else {
			set raw_assumptions "none"
		}
		##################################### Construction et mise en forme de la rponse  afficher
		# on construit une liste des rponses exploitables
		foreach pod_id $pod_id_list {
		 	if { ($pod_id eq "Input") && ([set pod_[set pod_id](title)] ne "Input interpretation") } {
		 		continue
		 	} elseif { [::tcl::string::trim [join [set pod_[set pod_id](results)]]] eq "" } {
		 		continue
		 	} else {
		 		lappend useable_pod_id_list $pod_id
		 	}
		}
		# si on n'a aucune rponse exploitable, on arrte
		if { ![info exists useable_pod_id_list] } {
			::Wolframagaz::error missing_pod $chan
			::http::cleanup $token
			return
		# si on a des rsultats exploitables, on continue
		} else {
			# pour un rsultat de type mathmatique, si on a un pod_id "DecimalApproximation", on le place au dbut de $useable_pod_id_list
			if { ($queryresult(datatypes) eq "Math") && ([set index [lsearch $useable_pod_id_list "DecimalApproximation"]] != -1) } {
					set useable_pod_id_list [linsert [lreplace $useable_pod_id_list $index $index] 0 "DecimalApproximation"]
			}
			set output ""
			set result_categories_offset 1
			lappend result_categories_offsets 1
			set counter 1
			# on assemble la ligne de rsultats
			foreach pod_id $useable_pod_id_list {
				foreach {subpod_title result} [set pod_[set pod_id](results)] {
					if { $result ne "" } {
						# on tente une mise en forme des rsultats au passage, notamment
						# les | utiliss comme sparateur; cependant, on ne le fait pas si
						# la requte est de type mathmatique pour respecter sa symbolique
						if { $queryresult(datatypes) ne "Math" } { regsub -all {\s\|\s} $result ": " result }
						regsub -all {!!_:_!!} $result [::Wolframagaz::filter_codes $::Wolframagaz::results_separator $chan] result
						if { $subpod_title ne "" } { set subpod_title "[c $::Wolframagaz::subcategory_title_color $chan][set subpod_title]:[c e $chan]" }
						if { ![info exists sub_results] } {
							append sub_results "[if { $subpod_title ne "" } { set subpod_title "[set subpod_title] " } { set subpod_title }]$result"
						} else {
							append sub_results "[::Wolframagaz::filter_codes $::Wolframagaz::results_separator $chan][if { $subpod_title ne "" } { set subpod_title "[set subpod_title] " } { set subpod_title }]$result"
						}
					} else {
						append sub_results ""
					}
				}
				if { $sub_results ne "" } {
					if { ![info exists results] } {
						set temp_results "[c u $chan][c $::Wolframagaz::category_title_color $chan][set pod_[set pod_id](title)][c s $chan]!!_[set counter]_!!: $sub_results"
					} else {
						set temp_results "[::Wolframagaz::filter_codes $::Wolframagaz::categories_separator $chan][c u $chan][c $::Wolframagaz::category_title_color $chan][set pod_[set pod_id](title)][c s $chan]!!_[set counter]_!!: $sub_results"
					}
					append results $temp_results
					# on exporte chaque catgorie + son rsultat associ dans un array afin
					# de pouvoir ensuite afficher  loisir telle ou telle catgorie lors
					# d'une demande de prcisions
					set ::Wolframagaz::reusable_results_[set chan_hash]($counter) "[c u $chan][c $::Wolframagaz::category_title_color $chan][set pod_[set pod_id](title)][c s $chan]: $sub_results"
					lappend useable_pod_titles_list [set pod_[set pod_id](title)]
					lappend result_categories_offsets [set result_categories_offset [expr $result_categories_offset + [::tcl::string::length $temp_results]]]
				} else {
					append results ""
				}
				incr counter
				unset sub_results
			}
			set ::Wolframagaz::reusable_results_[set chan_hash](nick) $nick
			append output $results
			# Intgration des avertissements dans le rsultat  afficher
			if { ($::Wolframagaz::show_warnings) && ($warnings ne "none") } {
				set warnings_output "[c u $chan][::Wolframagaz::plural [llength $warnings] "Warning" "Warnings"][c u $chan]: "
				set counter 0
				foreach warning $warnings {
					if { $counter > 0 } { append warnings_output [::Wolframagaz::filter_codes $::Wolframagaz::results_separator $chan] }
					append warnings_output "$warning"
					incr counter
				}
				append warnings_output [::Wolframagaz::filter_codes $::Wolframagaz::categories_separator $chan]
			} else {
				set warnings_output ""
			}
			set output "[set warnings_output][set output]"
			# Si le rsultat est de type mathmatique, on affiche l'interprtation de
			# la requte au dbut de la ligne de rsultats
			if { $queryresult(datatypes) eq "Math" } {
				set output "[c b $chan][lindex [set pod_Input(results)] 1][c b $chan]: [set output]"
			}
			# dcoupage de la rponse en fragments d'une longueur limite
			set output [::Wolframagaz::split_line $output $::Wolframagaz::max_line_length]
			# on raccourcit le nombre de lignes de rsultats au maximum souhait
			if { [llength $output] > $::Wolframagaz::max_lines_for_primary_results } {
				set output [lrange $output 0 [expr $::Wolframagaz::max_lines_for_primary_results - 1]]
				# la rponse a t tronque, on rend visible les numros des catgories
				# de rsultat
				regsub -all {!!_([0-9]+)_!!} $output " [c $::Wolframagaz::category_number_color $chan](\\1)\017" output
				# on insre un symbole  la fin de la dernire ligne de rsultats pour
				# indiquer que l'affichage a t tronqu.
				set output [lreplace $output end end [::tcl::string::replace [lindex $output end] end-[::tcl::string::length [::Wolframagaz::filter_codes $::Wolframagaz::line_cut_pattern $chan]] end [::Wolframagaz::filter_codes $::Wolframagaz::line_cut_pattern $chan]]]
				set displayed_output_length [::tcl::string::length [join $output]]
				set truncated 1
			} else {
				# la rponse n'a pas t tronque, on cache les numros des catgories
				# de rsultat
				regsub -all {!!_([0-9]+)_!!} $output "" output
				set truncated 0
			}
			################################################# Affichage de la rponse
			# affichage des lignes de rsultats
			foreach output_line $output {
				puthelp "PRIVMSG $chan :$output_line"
			}
			# Si la ligne de rsultats a t tronque et si on l'option
			# suggest_additional_categories_if_truncated le permet, on affiche une liste des
			# catgories de rsultat possibles
			if { $::Wolframagaz::suggest_additional_categories_if_truncated && $truncated } {
				# on vrifie quelles catgories de rsultats ont pu tre affiches selon
				# les rglages du script, afin de ne proposer que les autres
				set displayed_counter 0
				foreach offset $result_categories_offsets {
					if { ($displayed_output_length >= [lindex $result_categories_offsets $displayed_counter] - [::tcl::string::length [::Wolframagaz::filter_codes $::Wolframagaz::line_cut_pattern $chan]])
						&& (($displayed_counter + 1 >= [llength $result_categories_offsets] - 1)
						|| ($displayed_output_length < [lindex $result_categories_offsets [expr $displayed_counter + 1]] - [::tcl::string::length [::Wolframagaz::filter_codes $::Wolframagaz::line_cut_pattern $chan]]))
					} then {
						set remaining_useable_pod_titles_list [lrange $useable_pod_titles_list $displayed_counter end]
						break
					}
					incr displayed_counter
				}
				set output "Des rsultats additionnels sont disponibles dans les catgories suivantes : "
				set counter 1
				foreach pod_title $remaining_useable_pod_titles_list {
					incr displayed_counter
					if { $counter > 1 } { append output [::Wolframagaz::filter_codes $::Wolframagaz::categories_separator $chan] }
					append output "$pod_title [c $::Wolframagaz::category_number_color $chan]($displayed_counter)[c e $chan]"
					incr counter
				}
				# on coupe la rponse en fragments d'une longueur limite
				set output [::Wolframagaz::split_line $output $::Wolframagaz::max_line_length]
				# affichage des lignes des catgories de rsultats
				foreach output_line $output {
					puthelp "PRIVMSG $chan :$output_line"
				}
				# on cre un bind  validit limite dans le temps afin de pouvoir
				# rpondre  d'ventuelles demandes de prcisions
				bind pubm $::Wolframagaz::command_flags "$chan *" ::Wolframagaz::request_additional_results
				utimer $::Wolframagaz::results_life_duration [list ::Wolframagaz::previous_results_just_expired $chan]
				# On cre un index des catgories afin de pouvoir suivre celles qui sont
				# interroges. Cette variable est utilise si Wolframagaz n'est pas
				# autoris  rpter plusieurs fois la mme catgorie de rponse
				set ::Wolframagaz::reusable_results_[set chan_hash](remaining_categories) [split [::tcl::string::repeat 1 [expr [array size ::Wolframagaz::reusable_results_[set chan_hash]] - 1]] ""]
			} else {
				array unset ::Wolframagaz::reusable_results_[set chan_hash]
			}
		}
		::http::cleanup $token
	} else {
		Wolframagaz::error socket_error $chan
		::http::cleanup $token
	}
	return
}


 ##############################################################################
### on demande  (r)afficher une catgorie de rsultats
 ##############################################################################
proc Wolframagaz::request_additional_results {nick host hand chan arg} {
	set chan_hash [md5 $chan]
	if { (![channel get $chan wolfram])
		|| (![info exists ::Wolframagaz::reusable_results_[set chan_hash]])
		|| ($nick ne [set ::Wolframagaz::reusable_results_[set chan_hash](nick)])
		|| (![regexp {^[0-9]+$} $arg])
		|| (!$arg) || ($arg > [expr [array size ::Wolframagaz::reusable_results_[set chan_hash]] - 2])
		|| (($Wolframagaz::antiflood_enabled)
		&& (([::Wolframagaz::antiflood user $nick $host $chan]) || ([::Wolframagaz::antiflood chan $nick $host $chan])))
	} then {
		return
	# si l'affichage de cette catgorie de rsultats a dj t demande, on ne la raffiche pas.
	} elseif { !($::Wolframagaz::is_allowed_to_repeat) && (![lindex [set ::Wolframagaz::reusable_results_[set chan_hash](remaining_categories)] [expr $arg - 1]]) } {
		puthelp "PRIVMSG $chan :[c 14 $chan]\[Wolframagaz\][c e $chan] Veuillez relire un peu plus haut."
		return
	} else {
		set output [::Wolframagaz::split_line [set ::Wolframagaz::reusable_results_[set chan_hash]($arg)] $::Wolframagaz::max_line_length] 
		# on raccourcit le nombre de lignes du rsultat au maximum souhait
		if { [llength $output] > $::Wolframagaz::max_lines_per_additional_result } {
			set output [lrange $output 0 [expr $::Wolframagaz::max_lines_per_additional_result - 1]]
			# on insre un symbole  la fin de la dernire ligne de rsultats pour
			# indiquer que l'affichage a t tronqu.
			set output [lreplace $output end end [::tcl::string::replace [lindex $output end] end-[::tcl::string::length [::Wolframagaz::filter_codes $::Wolframagaz::line_cut_pattern $chan]] end [::Wolframagaz::filter_codes $::Wolframagaz::line_cut_pattern $chan]]]
		}
		# affichage des lignes des catgories de rsultats
		foreach output_line $output {
			puthelp "PRIVMSG $chan :$output_line"
		}
		# on note qu'on a dj affich cette catgorie
		set ::Wolframagaz::reusable_results_[set chan_hash](remaining_categories) [lreplace [set ::Wolframagaz::reusable_results_[set chan_hash](remaining_categories)] [expr $arg - 1] [expr $arg - 1] 0]
		# on arrte le timer prcdent et on en relance un autre pour donner le
		# temps de consulter des catgories supplmentaires
		foreach running_utimer [utimers] {
			if { [::tcl::string::match "::Wolframagaz::previous_results_just_expired $chan" [lindex $running_utimer 1]] } {
				killutimer [lindex $running_utimer 2]
			}
		}
		utimer $::Wolframagaz::results_life_duration [list ::Wolframagaz::previous_results_just_expired $chan]
	}
}


 ##############################################################################
### expiration de la validit des rsultats de la dernire requte pour $chan
 ##############################################################################
proc Wolframagaz::previous_results_just_expired {chan} {
	array unset ::Wolframagaz::reusable_results_[md5 $chan]
	unbind pubm $::Wolframagaz::command_flags "$chan *" ::Wolframagaz::request_additional_results
}


 ##############################################################################
### erreurs
 ##############################################################################
proc Wolframagaz::error {type chan} {
	switch -- $type {
		parsetimedout {
			puthelp "PRIVMSG $chan :[c 04 $chan]\[Wolframagaz - erreur\][c e $chan] Temps dpass lors du traitement de la requte par WolframAlpha."
		}
		request_failed {
			puthelp "PRIVMSG $chan :[c 04 $chan]\[Wolframagaz - erreur\][c e $chan] WolframAlpha ne sait pas comment interprter votre requte."
		}
		missing_pod {
			puthelp "PRIVMSG $chan :[c 04 $chan]\[Wolframagaz - erreur\][c e $chan] Aucun rsultat exploitable n'a pu tre rcupr."
		}
		missing_queryresult {
			puthelp "PRIVMSG $chan :[c 04 $chan]\[Wolframagaz - erreur\][c e $chan] Aucune information identifiable n'a pu tre rcupre. Le site www.wolframalpha.com rencontre peut-tre un problme."
		}
		socket_error {
			puthelp "PRIVMSG $chan :[c 04 $chan]\[Wolframagaz - erreur\][c e $chan] La connexion au site n'a pas pu tre tablie dans les temps. Veuillez ressayer plus tard."
		}
		default {
			puthelp "PRIVMSG $chan :[c 04 $chan]\[Wolframagaz - erreur\][c e $chan] $type"
		}
	}
	return
}


 ##############################################################################
### traduction des tips, messages d'erreur, ...
 ##############################################################################
proc Wolframagaz::translate {data} {
	switch -- $data {
		"Check your spelling, and use English" {
			return "Vrifiez votre orthographe et utilisez l'anglais pour formuler votre requte."
		}
		"Try spelling out abbreviations" {
			return "Essayez d'crire les abrviations en toutes lettres."
		}
		"Invalid appid" {
			return "Cl d'API invalide"
		}
		"Appid missing" {
			return "La cl d'API est manquante dans l'url de requte"
		}
		"input parameter not present in query" {
			return "argument de recherche manquant"
		}
		default {
			return $data
		}
	}
}


 ##############################################################################
### dcoupage d'une ligne trop longue en plusieurs lignes
 ##############################################################################
proc Wolframagaz::split_line {data {limit 1}} {
	incr limit -1
	set data [::tcl::string::trim $data]
	set data_length [::tcl::string::length $data]
	if { $data_length <= $limit } {
		return [list $data]
	} else {
		set cursor 0
		# Note : si l'espace le plus proche est situ  plus de 50% de la fin d'un
		# fragment, on n'hsite pas  couper au milieu d'un mot.
		set middle_pos [expr round($limit / 2.0)]
		while { $cursor < $data_length } {
			if { ([set cut_index [::tcl::string::last " " $data [expr {$cursor + $limit + 1}]]] == -1)
				|| ($cut_index <= $cursor)
				|| ($data_length - $cursor < $limit)
				|| ([expr $cut_index - $cursor] < $middle_pos)
			} then {
				set cut_index [expr {$cursor + $limit}]
			}
			lappend output [::tcl::string::trimright [::tcl::string::range $data $cursor $cut_index]]
			set cursor [expr {$cut_index + 1}]
		}
		return $output
	}
}


 ##############################################################################
### accorde au singulier ou au pluriel en retournant "" ou "s" selon $value
 ##############################################################################
proc Wolframagaz::plural {value singular plural} {
	if { ($value >= 2) || ($value <= -2) } { return $plural } { return $singular }
}


 ##############################################################################
### filtrage des codes de couleur/gras/soulignement si le mode +c est dtect
### sur le chan, ou si le mode monochrome est activ manuellement
### (rserv au fonctionnement interne du script)
 ##############################################################################
proc Wolframagaz::c {code chan} {
	if { ($::Wolframagaz::monochrome) || ($code eq "") || (($chan ne "-") && ([string match *c* [lindex [split [getchanmode $chan]] 0]])) } {
		return ""
	} else {
		switch -- $code {
			b { return "\002" }
			u { return "\037" }
			r { return "\026" }
			e { return "\003" }
			s { return "\017" }
			default { return "\003$code" }
		}
	}
}


 ##############################################################################
### filtrage des codes de couleur/gras/soulignement si le mode +c est dtect
### sur le chan, ou si le mode monochrome est activ manuellement
### (appliqu sur les variables configures par l'utilisateur)
 ##############################################################################
proc Wolframagaz::filter_codes {data chan} {
	if { ($::Wolframagaz::monochrome) || (($chan ne "-") && ([string match *c* [lindex [split [getchanmode $chan]] 0]])) } {
		return [regsub -all "\017" [stripcodes abcgru $data] ""]
	} else {
		return $data
	}
}


 ##############################################################################
### antiflood
 ##############################################################################
proc Wolframagaz::antiflood {type nick host chan} {
	variable antiflood_instances
	variable antiflood_msg_limiter
	set limiter_hash [md5 "[set type][set chan]"]
	if { ![info exists antiflood_msg_limiter($limiter_hash)] } { set antiflood_msg_limiter($limiter_hash) 0 }
	if { $type eq "user" } {
		set hash [md5 "[set host][set chan]"]
		if { ![info exists antiflood_instances($hash)] } { set antiflood_instances($hash) 0 }
		set max_instances $::Wolframagaz::max_instances_per_user
		set instance_length $::Wolframagaz::per_user_instance_length
	} else {
		set hash [md5 $chan]
		if { ![info exists antiflood_instances($hash)] } { set antiflood_instances($hash) 0 }
		set max_instances $::Wolframagaz::max_instances_per_chan
		set instance_length $::Wolframagaz::per_chan_instance_length
	}
	# l'antiflood a t dclench
  if { $antiflood_instances($hash) >= $max_instances } {
    if { !$antiflood_msg_limiter($limiter_hash) } {
      set antiflood_msg_limiter($limiter_hash) 1
      if {$type eq "user"} {
        putquick "privmsg $chan :[c 14 $chan]\[Wolframagaz\][c e $chan] Contrle de flood activ pour $nick. Veuillez ne pas monopoliser Wolframagaz pendant trop longtemps. (pas plus de $max_instances [::Wolframagaz::plural $max_instances "requte" "requtes"] en $instance_length [::Wolframagaz::plural $instance_length "seconde" "secondes"])."
      } else {
        putquick "privmsg $chan :[c 14 $chan]\[Wolframagaz\][c e $chan] Contrle de flood activ : pas plus de $max_instances [::Wolframagaz::plural $max_instances "requte" "requtes"] en $instance_length [::Wolframagaz::plural $instance_length "seconde" "secondes"]."
      }
      utimer $::Wolframagaz::antiflood_msg_interval [list ::Wolframagaz::antiflood_msg_reset $limiter_hash]
    }
		return 1
	# l'antiflood n'a pas t dclench
	} else {
		incr ::Wolframagaz::antiflood_instances($hash)
		utimer $instance_length [list ::Wolframagaz::antiflood_close_instance $hash]
		return 0
	}
}
proc Wolframagaz::antiflood_close_instance {hash} {
	variable antiflood_instances
	if { ([info exists antiflood_instances($hash)]) && ($antiflood_instances($hash) > 0) } {
		incr antiflood_instances($hash) -1
	}
}
proc Wolframagaz::antiflood_msg_reset {hash} {
	set ::Wolframagaz::antiflood_msg_limiter($hash) 0
}


 ##############################################################################
### conversion des caractres HTML tendus
 ##############################################################################
proc Wolframagaz::html_filter {data} {
	return [::tcl::string::map {
		"&agrave;"    ""   "&agrave;"    ""   "&aacute;"    ""   "&acirc;"     ""
		"&atilde;"    ""   "&auml;"      ""   "&aring;"     ""   "&aelig;"     ""
		"&ccedil;"    ""   "&egrave;"    ""   "&eacute;"    ""   "&ecirc;"     ""
		"&euml;"      ""   "&igrave;"    ""   "&iacute;"    ""   "&icirc;"     ""
		"&iuml;"      ""   "&eth;"       ""   "&ntilde;"    ""   "&ograve;"    ""
		"&oacute;"    ""   "&ocirc;"     ""   "&otilde;"    ""   "&ouml;"      ""
		"&divide;"    ""   "&oslash;"    ""   "&ugrave;"    ""   "&uacute;"    ""
		"&ucirc;"     ""   "&uuml;"      ""   "&yacute;"    ""   "&thorn;"     ""
		"&yuml;"      ""   "&quot;"      "\""  "&amp;"       "&"   "&euro;"      ""
		"&oelig;"     ""   "&Yuml;"      ""   "&nbsp;"      " "   "&iexcl;"     ""
		"&cent;"      ""   "&pound;"     ""   "&curren;"    ""   "&yen;"       ""
		"&brvbar;"    ""   "&brkbar;"    ""   "&sect;"      ""   "&uml;"       ""
		"&die;"       ""   "&copy;"      ""   "&ordf;"      ""   "&laquo;"     ""
		"&not;"       ""   "&shy;"       "-"  "&reg;"       ""   "&macr;"      ""
		"&hibar;"     ""   "&deg;"       ""   "&plusmn;"    ""   "&sup2;"      ""
		"&sup3;"      ""   "&acute;"     ""   "&micro;"     ""   "&para;"      ""
		"&middot;"    ""   "&cedil;"     ""   "&sup1;"      ""   "&ordm;"      ""
		"&raquo;"     ""   "&frac14;"    ""   "&frac12;"    ""   "&frac34;"    ""
		"&iquest;"    ""   "&Agrave;"    ""   "&Aacute;"    ""   "&Acirc;"     ""
		"&Atilde;"    ""   "&Auml;"      ""   "&Aring;"     ""   "&AElig;"     ""
		"&Ccedil;"    ""   "&Egrave;"    ""   "&Eacute;"    ""   "&Ecirc;"     ""
		"&Euml;"      ""   "&Igrave;"    ""   "&Iacute;"    ""   "&Icirc;"     ""
		"&Iuml;"      ""   "&ETH;"       ""   "&Dstrok;"    ""   "&Ntilde;"    ""
		"&Ograve;"    ""   "&Oacute;"    ""   "&Ocirc;"     ""   "&Otilde;"    ""
		"&Ouml;"      ""   "&times;"     ""   "&Oslash;"    ""   "&Ugrave;"    ""
		"&Uacute;"    ""   "&Ucirc;"     ""   "&Uuml;"      ""   "&Yacute;"    ""
		"&THORN;"     ""   "&szlig;"     ""   "\r"          "\n"  "\t"          ""
		"&apos;"      "\'"  "&#039;"      "\'"  "&#39;"       "\'"
		"&#34;"       "\'"  "&#38;"       "&"   "#91;"        "\("  "&#92;"       "\/"
		"&#93;"       ")"   "&#123;"      "("   "&#125;"      ")"   "&#163;"      ""
		"&#168;"      ""   "&#169;"      ""   "&#171;"      ""   "&#173;"      ""
		"&#174;"      ""   "&#180;"      ""   "&#183;"      ""   "&#185;"      ""
		"&#187;"      ""   "&#188;"      ""   "&#189;"      ""   "&#190;"      ""
		"&#192;"      ""   "&#193;"      ""   "&#194;"      ""   "&#195;"      ""
		"&#196;"      ""   "&#197;"      ""   "&#198;"      ""   "&#199;"      ""
		"&#200;"      ""   "&#201;"      ""   "&#202;"      ""   "&#203;"      ""
		"&#204;"      ""   "&#205;"      ""   "&#206;"      ""   "&#207;"      ""
		"&#208;"      ""   "&#209;"      ""   "&#210;"      ""   "&#211;"      ""
		"&#212;"      ""   "&#213;"      ""   "&#214;"      ""   "&#215;"      ""
		"&#216;"      ""   "&#217;"      ""   "&#218;"      ""   "&#219;"      ""
		"&#220;"      ""   "&#221;"      ""   "&#222;"      ""   "&#223;"      ""
		"&#224;"      ""   "&#225;"      ""   "&#226;"      ""   "&#227;"      ""
		"&#228;"      ""   "&#229;"      ""   "&#230;"      ""   "&#231;"      ""
		"&#232;"      ""   "&#233;"      ""   "&#234;"      ""   "&#235;"      ""
		"&#236;"      ""   "&#237;"      ""   "&#238;"      ""   "&#239;"      ""
		"&#240;"      ""   "&#241;"      ""   "&#242;"      ""   "&#243;"      ""
		"&#244;"      ""   "&#245;"      ""   "&#246;"      ""   "&#247;"      ""
		"&#248;"      ""   "&#249;"      ""   "&#250;"      ""   "&#251;"      ""
		"&#252;"      ""   "&#253;"      ""   "&#254;"      ""
		"&lt;"        "<"   "&gt;"        ">"
	} $data]
}


 ##############################################################################
### binds
 ##############################################################################
bind evnt - prerehash ::Wolframagaz::uninstall
foreach ::Wolframagaz::command $::Wolframagaz::commands {
	bind pub $::Wolframagaz::command_flags $::Wolframagaz::command ::Wolframagaz::main
}
unset ::Wolframagaz::command


putlog "[set ::Wolframagaz::scriptname] v[set ::Wolframagaz::version] (2012 MenzAgitat) a t charg."



# Annexe technique
# ----------------
# Variables notables renseignes par le parser :
# $queryresult = array contenant les proprits de la recherche
# $pod_id_list = liste des ID des pods
# $useable_pod_id_list = liste des ID des pods utilisables (pods non vides, sauf si title=Input)
# $useable_pod_titles_list = liste des titres des pods utilisables (pods non vides, sauf si title=Input)
# $pod_$pod_id = arrays contenant les proprits des pods
# $pod_$pod_id(results) = liste des rsultats pour $pod_id
# $tips = array contenant les proprits globales des tips
# $tips(results) = liste des tips
# $error = liste des erreurs ventuelles
# $warnings(results) = liste des warnings
# $assumptions = array contenant les proprits globales des assumptions
# $assumption_id_list = liste des ID des assumptions
# $assumption_$assumption_id = arrays contenant les proprits des assumptions
# $assumption_$assumption_id(results) = liste des rsultats pour $assumption_id
